module MassHighways
  class Event
    attr_accessor :event_id, :event_created_date, :event_start_date, :event_end_date,
      :last_update, :event_status, :event_category, :event_type, :event_sub_type,
      :roadway_name, :direction, :location_type, :primary_latitude, :primary_longitude,
      :secondary_latitude, :secondary_longitude, :location_description,
      :lane_blockage_description, :recurrence_description
    alias :read_attribute_for_serialization :send
    def self.parse(node)
      event = self.new
      event.event_id = node.search('EventId').first.text.to_i
      event.event_created_date = DateTime.parse node.search('EventCreatedDate').first.text
      event.event_start_date = DateTime.parse node.search('EventStartDate').first.text

      end_date = node.search('EventEndDate').first.text
      event.event_end_date = DateTime.parse end_date unless end_date.empty?

      event.last_update = DateTime.parse node.search('LastUpdate').first.text
      event.event_status = node.search('EventStatus').first.text
      event.event_category = node.search('EventCategory').first.text
      event.event_type = node.search('EventType').first.text
      event.event_sub_type = node.search('EventSubType').first.text

      event.roadway_name              = node.search('RoadwayName').first.text
      event.direction                 = node.search('Direction').first.text
      event.location_type             = node.search('LocationType').first.text
      event.primary_latitude          = node.search('PrimaryLatitude').first.text.to_f
      event.primary_longitude         = node.search('PrimaryLongitude').first.text.to_f

      secondary_latitude = node.search('SecondaryLatitude').first.text
      event.secondary_latitude        = secondary_latitude.to_i unless secondary_latitude == 'NaN'

      secondary_longitude = node.search('SecondaryLongitude').first.text
      event.secondary_longitude       = secondary_longitude.to_i unless secondary_longitude == 'NaN'

      event.location_description      = node.search('LocationDescription').first.text
      event.lane_blockage_description = node.search('LaneBlockageDescription').first.text
      event.recurrence_description    = node.search('RecurrenceDescription').first.text

      event
    end
  end
end
