module MassHighways
  class Pair
    attr_accessor :title, :direction, :origin, :destination, :speed, :freeflow, :status, :route, :pair_id, :travel_time, :stale

    alias :read_attribute_for_serialization :send
    def initialize
      @route = []
    end

    def self.parse(node)
      pair = self.new
      pair.pair_id = node.search('PairID').first.text.to_i
      pair.title = node.search('Title').first.text
      pair.direction = node.search('Direction').first.text
      pair.origin = node.search('Origin').first.text
      pair.destination = node.search('Destination').first.text
      pair.speed = node.search('Speed').first.text.to_f
      pair.travel_time = node.search('TravelTime').first.text.to_f
      pair.freeflow = node.search('FreeFlow').first.text.to_f

      node.search('Routes Route').each do |route_node|
        lat = route_node.search('lat').first.text.to_f
        lon = route_node.search('lon').first.text.to_f
        pair.route << { lat: lat, lon: lon }
      end

      pair
    end
  end
end
